config/routes.rb
# frozen_string_literal: true

require "sidekiq/web"

Rails.application.routes.draw do

  get "/healthcheck", to: "healthcheck#show"
  if Rails.env.development?
  # authenticate :user, lambda { |u| u.admin? } do
    mount LetterOpenerWeb::Engine, at: "/letter_opener"
  end

  authenticate :admin do
    mount Sidekiq::Web => '/sidekiq'
  end

  devise_scope :user do
    get '/admin_sign_in', to: "decidim/devise/sessions#new"
  end

  # authenticate(:user) do
  #   resources :conversations, to: redirect('/404')
  #   resources :notifications, to: redirect('/404')
  #   resource :user_interests, to: redirect('/404')
  # end

  # resources :profiles, only: [:show], param: :nickname, to: redirect('/404')
  # scope "/profiles/:nickname", format: false, constraints: { nickname: %r{[^\/]+} } do
  #   get "following", to: redirect('/404')
  #   get "followers", to: redirect('/404')
  #   get "badges", to: redirect('/404')
  #   get "groups", to: redirect('/404')
  #   get "members", to: redirect('/404')
  #   get "activity", to: redirect('/404')
  #   get "timeline", to: redirect('/404')
  # end

  # get "/search", to: redirect('/404')

  mount Decidim::Core::Engine => '/'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/decidim_controller.rb
# Entry point for Decidim. It will use the `DecidimController` as
# entry point, but you can change what controller it inherits from
# so you can customize some methods.
class DecidimController < ApplicationController
end

app/controllers/healthcheck_controller.rb
class HealthcheckController < ApplicationController
  def show
    render json: { status: 200, success: true }
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/decidim/initiatives/create_initiative_helper.rb
# frozen_string_literal: true

module Decidim
  module Initiatives
    # Helper methods for the create initiative wizard.
    module CreateInitiativeHelper
      def signature_type_options(initiative_form)
        return all_signature_type_options unless initiative_form.signature_type_updatable?
        return online_signature_type_options unless Decidim::Initiatives.respond_to?(:face_to_face_voting_allowed) && Decidim::Initiatives.face_to_face_voting_allowed
        return offline_signature_type_options unless online_signature_allowed?(initiative_form)

        all_signature_type_options
      end

      private

      def online_signature_type_options
        [
          [
            I18n.t(
              "online",
              scope: %w(activemodel attributes initiative signature_type_values)
            ), "online"
          ]
        ]
      end

      def offline_signature_type_options
        [
          [
            I18n.t(
              "offline",
              scope: %w(activemodel attributes initiative signature_type_values)
            ), "offline"
          ]
        ]
      end

      def all_signature_type_options
        Initiative.signature_types.keys.map do |type|
          [
            I18n.t(
              type,
              scope: %w(activemodel attributes initiative signature_type_values)
            ), type
          ]
        end
      end

      def online_signature_allowed?(initiative_form)
        Decidim::Initiatives.online_voting_allowed && online_signature_enabled_in_type?(initiative_form)
      end

      def online_signature_enabled_in_type?(initiative_form)
        ::Decidim::InitiativesType.find(initiative_form.type_id).online_signature_enabled
      end
    end
  end
end

app/helpers/decidim/omniauth_helper.rb
# frozen_string_literal: true

module Decidim
  # Helper that provides methods to enable or disable omniauth buttons
  module OmniauthHelper
    # Public: returns true if the social provider is enabled
    def social_provider_enabled?(provider)
      current_organization.enabled_omniauth_providers.key?(provider.to_sym)
    end

    # Public: returns true if any provider is enabled
    def any_social_provider_enabled?
      current_organization.enabled_omniauth_providers.any?
    end

    # Public: normalize providers names to they can be used for buttons
    # and icons.
    def normalize_provider_name(provider)
      provider.to_s.titleize
    end

    # Public: icon for omniauth buttons
    def oauth_icon(provider)
      return unless social_provider_enabled?(provider)
      info = current_organization.enabled_omniauth_providers[provider]

      if info
        icon_path = info[:icon_path]
        return external_icon(icon_path) if icon_path

        name = info[:icon]
      end

      name ||= provider.to_s.split("_").first
      icon(name)
    end

    # Public: pretty print provider name
    def provider_name(provider)
      provider.to_s.gsub(/_|-/, " ").camelize
    end
  end
end

app/views/decidim/account/show.html.erb
<div class="row">
  <%= decidim_form_for(@account, url: account_path, method: :put, html: { autocomplete: "nope" }) do |f| %>
    <input autocomplete="off" name="hidden" type="password" style="display:none;">
    <div class="columns large-4">
      <%= f.upload :avatar %>
    </div>

    <div class="columns large-8 end">
      <%= f.text_field :name, readonly: true %>
      <%= f.text_field :nickname %>

      <%= f.email_field :email %>

      <% if Devise.mappings[:user].confirmable? && current_user.unconfirmed_email.present? && current_user.unconfirmed_email != @account.email %>
        <div class="callout warning">
          <%= decidim_form_for current_user, as: :user, url: user_confirmation_path, html: { method: :post, class: "register-form new_user" } do |f| %>
            <%= f.hidden_field :email, value: current_user.unconfirmed_email %>
            <p>
              <%== t(".unconfirmed_email", email: current_user.unconfirmed_email ) %>
            </p>
            <%= f.submit t("devise.confirmations.new.resend_confirmation_instructions"), class: "button expanded small" %>
          <% end %>
        </div>
      <% end %>

      <%= f.url_field :personal_url %>
      <%= f.text_area :about, rows: 5 %>

      <% if @account.errors[:password].any? || @account.errors[:password_confirmation].any? %>
        <%= render partial: "password_fields", locals: { form: f } %>
      <% else %>
        <p>
          <a data-toggle="passwordChange" class="change-password"><%= t ".change_password" %></a>
        </p>
        <div id="passwordChange" class="toggle-show" data-toggler=".is-expanded">
          <%= render partial: "password_fields", locals: { form: f } %>
        </div>
      <% end %>

      <%= f.submit t(".update_account"), disable_with: true %>
    <% end %>
  </div>
</div>

app/views/decidim/admin/organization_appearance/_form.html.erb
<%= javascript_include_tag "decidim/slug_form" %>

<div class="card">
  <div class="card-divider">
    <h2 class="card-title"><%= t ".homepage_appearance_title" %></h2>
  </div>
  <div class="card-section">
    <div class="row column">
      <%= form.check_box :show_statistics %>
    </div>

    <div class="row column">
      <%= form.translated :editor, :description %>
    </div>

    <div class="row">
      <div class="columns xlarge-6 slug">
        <%= form.text_field :cta_button_path %>
        <p class="help-text"><%== t(".cta_button_path_help", url: decidim_form_slug_url("", form.object.cta_button_path)) %></p>
      </div>

      <div class="columns xlarge-6">
        <%= form.translated :text_field, :cta_button_text %>
        <p class="help-text"><%= t(".cta_button_text_help") %></p>
      </div>
    </div>
  </div>
</div>

<div class="card">
  <div class="card-divider">
    <h2 class="card-title"><%= t ".homepage_highlighted_content_banner_title" %></h2>
  </div>
  <div class="card-section">
    <div class="row column">
      <%= form.check_box :highlighted_content_banner_enabled %>
    </div>

    <div class="row column">
      <%= form.translated :text_area, :highlighted_content_banner_title %>
    </div>

    <div class="row column">
      <%= form.translated :editor, :highlighted_content_banner_short_description %>
    </div>

    <div class="row column">
      <%= form.translated :text_area, :highlighted_content_banner_action_title %>
    </div>

    <div class="row column">
      <%= form.translated :text_area, :highlighted_content_banner_action_subtitle %>
    </div>

    <div class="row column">
      <%= form.url_field :highlighted_content_banner_action_url %>
    </div>

    <div class="row">
      <div class="columns xlarge-6">
        <%= form.upload :highlighted_content_banner_image %>
      </div>
    </div>
  </div>
</div>

<div class="card">
  <div class="card-divider">
    <h2 class="card-title"><%= t ".omnipresent_banner_appearance_title" %></h2>
  </div>
  <div class="card-section">
    <div class="row column">
      <%= form.check_box :enable_omnipresent_banner %>
    </div>

    <div class="row column">
      <%= form.translated :text_field, :omnipresent_banner_title %>
    </div>

    <div class="row column">
      <%= form.translated :text_field, :omnipresent_banner_short_description %>
    </div>

    <div class="row column">
      <%= form.url_field :omnipresent_banner_url %>
    </div>
  </div>
</div>

<div class="card">
  <div class="card-divider">
    <h2 class="card-title"><%= t ".layout_appearance_title" %></h2>
  </div>
  <div class="card-section">
    <div class="row">
      <div class="columns xlarge-6">
        <%= form.upload :logo %>
      </div>

      <div class="columns xlarge-6">
        <%= form.upload :favicon %>
      </div>
    </div>

    <div class="row">
      <div class="columns xlarge-6">
        <%= form.upload :official_img_header %>
      </div>

      <div class="columns xlarge-6">
        <%= form.upload :official_img_footer %>
      </div>
    </div>

    <div class="row">
      <div class="columns xlarge-6">
        <%= form.text_field :official_url %>
      </div>
    </div>

    <% if Decidim.enable_html_header_snippets %>
      <div class="row column">
        <%= form.text_area :header_snippets %>
        <p class="help-text"><%= t(".header_snippets_help") %></p>
      </div>
    <% end %>
  </div>
</div>

<div class="card">
  <div class="card-divider">
    <h2 class="card-title"><%= t ".colors_title" %></h2>
  </div>

  <div class="card-section">
    <%= form.check_box :enable_custom_colors, checked: current_organization.colors.present? %>
  </div>

  <div class="card-section <%= "hide" if current_organization.colors.empty? %>" id="custom_colors_wrapper">
    <div class="row">
      <div class="columns xlarge-6">
        <%= form.color_field :primary_color, value: current_organization.colors["primary"] %>
      </div>

      <div class="columns xlarge-6">
        <%= form.color_field :secondary_color, value: current_organization.colors["secondary"] %>
      </div>
    </div>

    <div class="row">
      <div class="columns xlarge-6">
        <%= form.color_field :success_color, value: current_organization.colors["success"] %>
      </div>

      <div class="columns xlarge-6">
        <%= form.color_field :warning_color, value: current_organization.colors["warning"] %>
      </div>
    </div>

    <div class="row">
      <div class="columns xlarge-6">
        <%= form.color_field :alert_color, value: current_organization.colors["alert"] %>
      </div>
    </div>
  </div>
</div>

<script type="text/javascript">
  $(() => {
    $('label[for="organization_enable_custom_colors"]').click((event) => {
      const $enableCustomColors = $(event.delegateTarget).find("#organization_enable_custom_colors").is(":checked");
      if ($enableCustomColors) {
        $("#custom_colors_wrapper").removeClass("hide");
      } else {
        $("#custom_colors_wrapper").addClass("hide");
      }
    });
  });
</script>

app/views/decidim/authorization_modals/_content.html.erb
<% if current_user && !current_user.verifiable? %>
  <div class="missing-confirmation">
    <h2 class="section-heading"><%= t ".unconfirmed.title" %></h2>
  </div>
  <p><%= t ".unconfirmed.explanation_html", email: current_user.email %></p>
  <p><%= t ".unconfirmed.confirmation_instructions" %></p>
  <div class="row">
    <div class="columns medium-8 medium-offset-2">
      <%= link_to t(".unconfirmed.request_confirmation_instructions"), new_confirmation_path(Decidim::User), class: "button expanded" %>
    </div>
  </div>
<% else %>
  <% base_code = authorizations.global_code || :missing %>
  <div class="<%= base_code %>-authorization">
    <h2 class="section-heading"><%= t ".#{base_code}.title" %></h2>
  </div>
  <% authorizations.statuses.each do |status| %>
    <% next if status.ok? || (authorizations.global_code && status.code != base_code) || authorization_anti_affinity.include?(status.handler_name) %>
    <p class="lead"><%= t ".#{status.code}.explanation", authorization: t("#{status.handler_name}.name", scope: "decidim.authorization_handlers") %></p>
    <% if status.data[:extra_explanation] %>
      <p class="extra-explanation"><%= t status.data[:extra_explanation][:key], **status.data[:extra_explanation][:params] %></p>
    <% end %>
    <% status.data[:fields].each do |field, value| %>
      <p class="invalid_field"><strong><%= value %></strong></p>
    <% end %>
    <div class="row">
      <div class="columns medium-8 medium-offset-2">
        <% if status.data[:action].present? %>
          <%= link_to t(".#{status.code}.#{status.data[:action]}", authorization: t("#{status.handler_name}.name", scope: "decidim.authorization_handlers")), authorize_action_path(status.handler_name), class: "button expanded" %>
        <% else %>
          <button class="button expanded" data-close><%= t ".#{status.code}.ok" %></button>
        <% end %>
      </div>
    </div>
    <% if status.data[:cancel] %>
      <div class="text-center">
        <button class="link" data-close><%= t ".#{status.code}.cancel" %></button>
      </div>
    <% end %>
  <% end %>
  <% disabled_methods.each do |handler| %>
    <p class="explanation">
      <%= t ".missing.explanation", authorization: t("#{handler.name}.name", scope: "decidim.authorization_handlers") %>
    </p>
    <%= link_to t("sign_out", scope: "layouts.decidim.user_menu"), decidim.destroy_user_session_path, method: :delete, class: "button expanded" %>
  <% end %>
<% end %>

app/views/decidim/authorization_modals/show.html.erb
<%= render partial: "decidim/authorization_modals/content" %>
<button class="close-button" data-close aria-label="Close modal" type="button">
  <span aria-hidden="true">&times;</span>
</button>

app/views/decidim/initiatives/admin/answers/_info_initiative.html.erb
<div class="card">
  <div class="card-divider">
    <h2 class="card-title">
      <%= link_to "#{t ".initiatives"} > ", initiatives_path %>
      <%= decidim_sanitize translated_attribute(initiative.title) %>
    </h2>
  </div>

  <div class="card-section">
    <div class="author-row">
      <div class="author--avatar">
        <%= image_tag initiative.author.avatar_url %>
      </div>
      <div class="author--name">
        <%= initiative.author.name %>
      </div>
<!--      <div class="author--actions">-->
        <%# if authorizations && authorizations.any? && authorizations.first.metadata.present? %>
          <%#= metadata_modal_button_to authorizations.first, method: :get, remote: true, class: "button tiny hollow" do %>
            <%#= icon "shield" %>
            <%#= t "actions.metadata", scope: "decidim.verifications.omniauth.admin.authorizations.index" %>
          <%# end %>
        <%# end %>
<!--      </div>-->
    </div>
  </div>

  <div class="card-section initiative-info">
    <div class="row column">
      <strong><%= t ".description" %></strong>
      <div class="description">
        <%= decidim_sanitize(translated_attribute(initiative.description)) %>
      </div>
    </div>
    <div class="row column flex-column">
      <div class="info-box">
        <strong><%= t ".created_at" %></strong>
        <p><%= l initiative.created_at, format: :decidim_short %></p>
      </div>
      <div class="info-box">
        <strong><%= t ".state" %></strong>
        <p><%= I18n.t(initiative.state, scope: "decidim.initiatives.admin_states") %></p>
      </div>
      <div class="info-box">
        <strong><%= t ".initiative_votes_count" %></strong>
        <p class="text-right"><b><%= initiative.online_votes_count %></b>/<%= initiative.scoped_type.supports_required %></p>
      </div>
    </div>
  </div>
</div>

<%= render partial: "decidim/shared/authorization_modal" %>

<%= stylesheet_link_tag "decidim/admin/initiatives-extras" %>
<%= javascript_include_tag "decidim/admin/reveal" %>

app/views/decidim/initiatives/create_initiative/fill_data.html.erb
<% content_for :back_link do %>
  <%= link_to :back do %>
    <%= icon "chevron-left", class: "icon--small" %>
    <%= t(".back") %>
  <% end %>
<% end %>

<div class="row column">
  <div class="medium-centered">
    <div class="callout secondary">
      <%== t ".fill_data_help" %>
      <% if Decidim::StaticPage.exists?(slug: "introduire_ou_soutenir_une_petition") %>
        <%= link_to t(".more_information"), decidim.page_path("introduire_ou_soutenir_une_petition"), target: "_blank" %>.
      <% elsif Decidim::StaticPage.exists?(slug: "initiatives") %>
        <%= link_to t(".more_information"), decidim.page_path("initiatives"), target: "_blank" %>.
      <% end %>
    </div>
  </div>
</div>
<br>
<div class="row">
  <div class="medium-centered">
    <div class="card">
      <div class="card__content">
        <%= decidim_form_for(@form, url: next_wizard_path, method: :put, html: { class: "form new_initiative_form" }) do |f| %>
          <%= f.hidden_field :type_id %>
          <div class=section>
            <% unless single_initiative_type? %>
              <div class="field">
                <label for="type_description"><%= t ".initiative_type" %></label>
                <%= text_field_tag :type_description, strip_tags(translated_attribute(initiative_type.title)), readonly: true %>
              </div>
            <% end %>

            <div class="field">
              <%= f.text_field :title, autofocus: true, required: true %>
            </div>

            <div class="field">
              <%= f.text_area :description, rows: 8, maxlength: 10000, autocomplete: :off, required: true %>
            </div>

            <% if initiative_type.no_signature_allowed? %>
              <div class="field">
                <%= f.check_box :no_signature, help_text: t(".help_text") %>
              </div>
            <% end %>

            <% signature_type_options = signature_type_options(f.object) %>
            <% if signature_type_options.length == 1 %>
              <%= f.hidden_field :signature_type, value: signature_type_options.first.last %>
            <% else %>
              <div class="field">
                <%= f.select :signature_type, signature_type_options %>
              </div>
            <% end %>

            <% if scopes.length == 1 %>
              <%= f.hidden_field :scope_id, value: scopes.first.scope&.id %>
            <% else %>
              <div class="field">
                <%= f.select :scope_id,
                             scopes.map { |scope| [translated_attribute(scope.scope_name), scope&.scope&.id] },
                             prompt: t(".select_scope") %>
              </div>
            <% end %>

            <% if initiative_type.custom_signature_end_date_enabled? %>
              <div class="field signature-end-date">
                <%= f.date_field :signature_end_date %>
              </div>
            <% end %>

            <% if Decidim::UserGroups::ManageableUserGroups.for(current_user).verified.any? %>
              <div class="field">
                <%= f.select :decidim_user_group_id,
                             Decidim::UserGroups::ManageableUserGroups.for(current_user).verified.map { |g| [g.name, g.id] },
                             prompt: current_user.name %>
              </div>
            <% end %>

            <fieldset>
              <legend><b><%= t("attachment_legend", scope: "decidim.initiatives.initiatives.edit") %></b></legend>
              <div id="attachment-wrapper">
                <%= f.fields_for :attachment, @form.attachment do |nested_form| %>
                  <div class="field">
                    <%= nested_form.text_field :title %>
                  </div>

                  <div class="field">
                    <%= nested_form.upload :file, optional: false, accept: "application/pdf" %>
                  </div>

                  <% if @form.errors[:attachment].present? %>
                    <% @form.errors[:attachment].each do |message| %>
                      <small class="form-error is-visible">
                        <%= message %>
                      </small>
                    <% end %>
                  <% end %>
                <% end %>
              </div>
            </fieldset>
          </div>
          <div class="actions">
            <%= f.submit t(".continue"), class: "button expanded", data: { disable_with: t(".continue") } %>
          </div>
        <% end %>
      </div>
    </div>
  </div>
</div>

app/views/decidim/initiatives/create_initiative/previous_form.html.erb
<% content_for :back_link do %>
  <%= link_to :back do %>
    <%= icon "chevron-left", class: "icon--small" %>
    <%= t(".back") %>
  <% end %>
<% end %>

<div class="row">
  <div class="medium-centered">
    <div class="callout secondary">
      <%== t ".help" %>
    </div>
  </div>
</div>
<br>
<div class="row">
  <div class="medium-centered">
    <div class="card">
      <div class="card__content">
        <%= decidim_form_for(@form, url: next_wizard_path, method: :put, html: { class: "form new_initiative_previous_form" }) do |f| %>
          <%= f.hidden_field :type_id %>

          <div class="field">
            <%= f.text_field :title, autofocus: true, required: true %>
          </div>

          <div class="field">
            <%= f.text_area :description, rows: 8, maxlength: 10000, autocomplete: :off, required: true %>
          </div>

          <div class="actions">
            <%= f.submit t(".continue"), class: "button expanded" %>
          </div>
        <% end %>
      </div>
    </div>
  </div>
</div>

app/views/decidim/pages/_standalone.html.erb
<div class="wrapper">
  <div class="row column">
    <div class="text-center">
      <h1 class="heading1 page-title">
        <%= title %>
      </h1>
    </div>

    <main>
      <%= cell "decidim/tos_page", :announcement %>

      <div class="columns small-12">
        <div class="card">
          <div class="card__content"><%= decidim_sanitize translated_attribute page.content %></div>
        </div>
      </div>

      <% if request.env['PATH_INFO'].include?("/cookies") %>

        <div class="columns small-12">
          <div class="card">
            <div class="card__content">
              <iframe
                style="border: 0; height: auto; width: 100%;"
                src="https://matomo.opensourcepolitics.eu/index.php?module=CoreAdminHome&action=optOut&language=fr&backgroundColor=&fontColor=3d393c&fontSize=15px&fontFamily=%22Roboto%20Slab%22%2C%20%22Roboto%22%2C%20%22Source%20Sans%20Pro%22%2C%20Helvetica%2C%20Arial%2C%20sans-serif"
              ></iframe>
            </div>
          </div>
        </div>

      <% end %>


      <%= cell "decidim/tos_page", :sticky_form %>
    </main>
  </div>
</div>

app/views/decidim/shared/_login_modal.html.erb
<div class="reveal" id="loginModal" data-reveal>
  <div>
    <h2 class="section-heading"><%= t(".please_sign_in") %></h2>
    <button class="close-button" data-close aria-label="Close modal"
            type="button">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <% if current_organization.sign_up_enabled? %>
    <div class="row">
      <div class="columns medium-8 medium-centered">
        <%= decidim_form_for(Decidim::User.new, as: :user, url: session_path(:user), html: { class: "register-form new_user" }) do |f| %>
          <div>
            <div class="field">
              <%= f.email_field :email, autofocus: true %>
            </div>
            <div class="field">
              <%= f.password_field :password, autocomplete: "off" %>
            </div>
          </div>
          <div class="actions">
            <%= f.submit t("devise.sessions.new.sign_in"), class: "button expanded" %>
          </div>
        <% end %>
        <% if current_organization.sign_up_enabled? %>
          <p class="text-center">
            <%= link_to t(".sign_up"), decidim.new_user_registration_path, class: "sign-up-link" %>
          </p>
        <% end %>
        <p class="text-center">
          <%= link_to t("devise.shared.links.forgot_your_password"), new_password_path(:user) %>
        </p>
      </div>
    </div>
    <% cache [current_organization, current_locale] do %>
      <%= render "decidim/devise/shared/omniauth_buttons_mini" %>
    <% end %>
  <% elsif current_organization.sign_in_enabled? %>
    <% cache [current_organization, current_locale] do %>
      <%= render partial: "decidim/devise/shared/omniauth_buttons", locals: { column_classes: "columns medium-8 small-12 medium-centered" } %>
    <% end %>
  <% else %>
    <div class="row">
      <div class="columns medium-8 medium-centered">
        <p>
          <%= t("sign_in_disabled", scope: "decidim.devise.sessions.new") %>
        </p>
      </div>
    </div>
    <% cache [current_organization, current_locale] do %>
      <%= render "decidim/devise/shared/omniauth_buttons" %>
    <% end %>
  <% end %>
</div>

app/views/decidim/verifications/authorizations/_granted_authorization.html.erb
<div class="card--list__item">
  <div class="card--list__text">
    <%= icon "lock-locked", class: "card--list__icon" %>
    <div>
      <h5 class="card--list__heading">
        <%= t("#{authorization.name}.name", scope: "decidim.authorization_handlers") %>
      </h5>
      <span class="text-small">
        <% if authorization.expired? %>
          <%= t("expired_at", scope: "decidim.authorization_handlers", timestamp: l(authorization.expires_at, format: :long)) %>
        <% else %>
          <%= t("granted_at", scope: "decidim.authorization_handlers", timestamp: l(authorization.granted_at, format: :long)) %>
          <% if authorization.expires_at.present? %>
            <%= t("expires_at", scope: "decidim.authorization_handlers", timestamp: l(authorization.expires_at, format: :long)) %>
          <% end %>
        <% end %>
      </span>
    </div>
  </div>
  <% if authorization.expired? %>
    <div class="card--list__data">
      <span class="card--list__data__icon">
        <%= icon "reload" %>
      </span>
    </div>
  <% end %>
</div>
<% if authorization.metadata.present? %>
  <div class="card--list__data">
    <%= table_from_data authorization.metadata.select { |k,v| ![:provider].include?(k) } %>
  </div>
<% end %>

app/views/decidim/verifications/metadata/_content.html.erb
<div class="reveal__header">
  <h3 class="card-title"><%= t ".title" %></h3>
</div>

<div class="card">
  <%= table_from_data @metadata.select { |k,v| ![:provider].include?(k) } %>
</div>

<div class="card">
  <div class="callout primary">
    <p>
      <%== t(".active_email", email: @user.email ) %>
    </p>
  </div>
</div>

app/views/decidim/verifications/metadata/_value.html.erb
<% if key == :scope_id %>
  <%= Decidim::Scope.find(value).name[current_locale] || Decidim::Scope.find(value).name[Decidim.default_locale] || value %>
<% else %>
  <%= value %>
<% end %>

app/views/layouts/decidim/_cookie_warning.html.erb
<% unless cookies_accepted? %>
  <div class="cookie-warning">
    <%= t(".description_html", link: link_to(t(".link_label"), decidim.page_path("cookies"), target: "_blank")) %>
    <div class="cookie-warning__action">
      <%= button_to t(".ok"), decidim.accept_cookies_path, method: :get, remote: true, class: "button tiny cookie-bar__button" %>
    </div>
  </div>
<% end %>

<script type="text/javascript">
  <!-- Consent for Matomo -->
  if(!!window._paq){
    var _paq = window._paq || [];
    <% if cookies_accepted? %>
      _paq.push(['setConsentGiven']);
    <% else %>
      _paq.push(['forgetConsentGiven']);
    <% end %>
  }
  <!-- End Consent for Matomo Code -->
</script>

app/views/layouts/decidim/_logo.html.erb
<% if organization %>
  <%= link_to decidim.root_url(host: organization.host) do %>
    <% if organization.logo.present? %>
      <%= image_tag organization.logo.medium.url, alt: organization.name %>
    <% else %>
      <span><%= organization.name %></span>
    <% end %>
  <% end %>
<% else %>
  <%= Decidim.application_name %>
<% end %>

app/views/layouts/decidim/_main_footer.html.erb
<div class="main-footer">
  <div class="row">
    <div class="footer-logo">
      <% if current_organization.official_img_footer? %>
        <%= link_to  current_organization.official_url, class: "main-footer__badge" do %>
          <%= image_tag current_organization.official_img_footer.url.to_s , alt: current_organization.name %>
        <% end %>
      <% end %>
    </div>
    <ul class="main__footer__nav footer-nav">
      <% if current_organization.static_pages.any? %>
        <% current_organization.static_page_topics.where(show_in_footer: true).each do |page_topic| %>
          <% if page_topic.pages.any? %>
            <li><%= link_to translated_attribute(page_topic.title), decidim.page_path(page_topic.pages.first) %></li>
          <% end %>
        <% end %>

        <% current_organization.static_pages.where(show_in_footer: true).each do |page| %>
          <li><%= link_to translated_attribute(page.title), decidim.page_path(page) %></li>
        <% end %>
      <% end %>
      <li><%= link_to t("layouts.decidim.footer.download_open_data"), decidim.open_data_download_path %></li>
      <% if cookies_accepted? %>
        <li><%= link_to t("layouts.decidim.footer.revoke_cookies"), "#", class: "reset-button" %></li>
      <% end %>
    </ul>
    <%= render partial: "layouts/decidim/social_media_links" %>
  </div>
</div>